<?php
	$dir = str_replace("wp-content/plugins/sbart-stats","",dirname(__FILE__));
	define('ABSPATH', $dir);
	require_once(ABSPATH .'/wp-config.php');
	
	if(!isset($_POST['sprawdz']))
	{
		if(get_option('czy_sprawdzac_indeksacje') == 1)
		{
			// sprawdź niezaindeksowane posty
			echo sprawdz_indeksacje(0,losuj_proxy());
		}
		if(get_option('czy_sprawdzac_wyindeksowanie') == 1)
		{
			// sprawdź zaindeksowane posty
			echo sprawdz_indeksacje(1,losuj_proxy());
		}
	}
	
	function losuj_proxy()
	{
		global $wpdb;
		$table_name = $wpdb->prefix . "sbart_stats";
		$serwery_proxy = $wpdb->get_results( "SELECT * FROM $table_name WHERE typ='proxy' AND czy_wlaczone = 1 ORDER BY RAND() LIMIT 1" );
		foreach($serwery_proxy as $proxy)
		{
			return $proxy->id;
		}
		
	}
	
	function wprowadz_zmienne($tresc, $uzytkownik, $artykul)
	{
		$tresc = str_replace("%nazwa_uzytkownika%", $uzytkownik->user_nicename, $tresc);
		$tresc = str_replace("%tytul_artykulu%", $artykul->post_title, $tresc);
		$tresc = str_replace("%adres_artykul%", get_permalink($artykul->ID), $tresc);
		$tresc = str_replace("%nazwa_serwisu%", get_settings('blogname'), $tresc);
		return $tresc;
	}
	
	function sprawdz_indeksacje($wariant,$proxy_id, $post_id = 0)
	{
		global $wpdb;
		$table_name = $wpdb->prefix . "sbart_stats";
		if(!get_option('data_pierwszego_sprawdzenia'))
		{
			add_option('data_pierwszego_sprawdzenia', date("Y-m-d H:i:s"));
		}
		
		if($wariant == 3)
		{
			$wynik = $wpdb->get_results("SELECT * FROM $wpdb->posts WHERE id =".$post_id);
		}
		else
		{
			$niesprawdzone_artykuly = $wpdb->get_var( "SELECT COUNT(*) FROM $wpdb->posts WHERE post_status = 'publish' AND post_type='post' AND google_index = $wariant AND google_checked = 0");
			
			if($niesprawdzone_artykuly == 0)
			{
				$wpdb->update($wpdb->prefix."posts", array('google_checked' => 0), array( 'post_status' => 'publish', 'post_type' => 'post', 'google_index' => $wariant));
			}
			$wynik = $wpdb->get_results("SELECT * FROM $wpdb->posts WHERE post_status = 'publish' AND post_type='post' AND google_index = $wariant ORDER by google_checked ASC LIMIT 1");
		}
		
		foreach ( $wynik as $artykul ) 
		{
			$url = get_permalink($artykul->ID);
			$url = str_replace("http://", "",$url);
			$url = str_replace("https://", "",$url);
			if(substr($url, 0, 4) == "www.") $url = str_replace("www.", "",$url);
			
			preg_match("/([^\/]+)/",strrev($url),$podstrona);
			$liczba_znakow_adresu = strlen($url);
			$liczba_znakow_podstrony = strlen($podstrona[1]);
			
			$wynik_exp = '/<h3 class="r"><a href="(.*?)"/si';
			$rC = curl_init();
			if($proxy_id == 11)
			{
				curl_setopt($rC,CURLOPT_URL, 'http://www.google.pl/search?hl=pl&q=inurl:'.$url);
			}
			else
			{
				$adres_proxy = $wpdb->get_var( "SELECT nazwa FROM $table_name WHERE id = $proxy_id" );
				curl_setopt($rC,CURLOPT_URL, $adres_proxy.'?url=http://www.google.pl/search?hl=pl%26q=inurl:'.$url);
			}
			curl_setopt($rC,CURLOPT_RETURNTRANSFER,true);
			curl_setopt($rC,CURLOPT_HEADER, false);
			curl_setopt($rC, CURLOPT_FOLLOWLOCATION, false);
			curl_setopt($rC,CURLOPT_USERAGENT, 'Opera/9.80 (Windows NT 6.1; U; Edition Campaign 21; pl) Presto/2.6.30 Version/10.61');
			$wynik_content = curl_exec( $rC );
			$http_code = curl_getinfo($rC, CURLINFO_HTTP_CODE);
			curl_close( $rC );
			//echo $wynik_content;
			preg_match_all($wynik_exp,$wynik_content,$wynik_strony);
			$url = str_replace("/", "\/",$url);
			$url = str_replace("?", "\?",$url);
			$url = str_replace(".", "\.",$url);
			$url = str_replace("&", "\&",$url);
			$url = str_replace("+", "\+",$url);
			if($http_code == 200 && trim($wynik_content) != "302")
			{
				$czy_wpis_zaindeksowany = 0;
				foreach($wynik_strony[1] as $pozycja)
				{
					
					if(preg_match("/$url/",$pozycja))
					{
						$czy_wpis_zaindeksowany = 1;
						break;
					}
				}
				if($czy_wpis_zaindeksowany == 1)
				{
					$info = "Wpis o adresie <strong>".get_permalink($artykul->ID)."</strong> jest zaindeksowany w Google</br>";
					if($artykul->google_index == 0 && (($artykul->google_info == 1 && get_option('czy_powiadamiac_o_indeksacji') == 1 && get_option('stan_indeksacji_pozwol_decydowac') == 1) || (get_option('czy_powiadamiac_o_indeksacji') == 1 && get_option('stan_indeksacji_zawsze_powiadamiaj') == 1)))
					{
						global $current_user;
						$contributor = get_userdata($artykul->post_author);
						$subject = wprowadz_zmienne(stripslashes($wpdb->get_var( "SELECT nazwa FROM $table_name WHERE id = 8" )),$contributor, $artykul);
						$message = wprowadz_zmienne(stripslashes($wpdb->get_var( "SELECT wartosc FROM $table_name WHERE id = 8" )),$contributor, $artykul);
						$headers = "From: ".get_settings('blogname')." <".get_settings('admin_email').">\r\n";
						wp_mail( $contributor->user_email, $subject, $message, $headers);
					}
					if($artykul->google_index == 0)
					{
						$wpdb->update($wpdb->prefix."posts", array('google_date' => date("Y-m-d H:i:s")), array( 'ID' => $artykul->ID));
					}
					$wpdb->update($wpdb->prefix."posts", array('google_index' => 1, 'google_checked' => 1), array( 'ID' => $artykul->ID));
					$wpdb->update($wpdb->prefix."sbart_stats", array('wartosc' => 'OK'), array( 'ID' => $proxy_id));
					break;
				}
				else
				{
					$info = "Wpis o adresie <strong>".get_permalink($artykul->ID)."</strong> nie jest zaindeksowany w Google</br>";
					if($artykul->google_index == 1 && (($artykul->google_info == 1 && get_option('czy_powiadamiac_o_indeksacji') == 1 && get_option('stan_indeksacji_pozwol_decydowac') == 1) || (get_option('czy_powiadamiac_o_indeksacji') == 1 && get_option('stan_indeksacji_zawsze_powiadamiaj') == 1)))
					{
						global $current_user;
						$contributor = get_userdata($artykul->post_author);
						$subject = wprowadz_zmienne(stripslashes($wpdb->get_var( "SELECT nazwa FROM $table_name WHERE id = 9" )),$contributor, $artykul);
						$message = wprowadz_zmienne(stripslashes($wpdb->get_var( "SELECT wartosc FROM $table_name WHERE id = 9" )),$contributor, $artykul);
						$headers = "From: ".get_settings('blogname')." <".get_settings('admin_email').">\r\n";
						wp_mail( $contributor->user_email, $subject, $message, $headers);
					}
					$wpdb->update($wpdb->prefix."posts", array('google_index' => 0, 'google_checked' => 1), array( 'ID' => $artykul->ID));
					$wpdb->update($wpdb->prefix."sbart_stats", array('wartosc' => 'OK'), array( 'ID' => $proxy_id));
					break;
				}
			}
			elseif(($http_code == 302 && $proxy_id == 11) || trim($wynik_content) == "302")
			{
				$info =  "Serwer z którego sprawdzane była indeksacja został tymczasowo zbanowany przez Google.</br>";
				$wpdb->update($wpdb->prefix."sbart_stats", array('wartosc' => 'BAN'), array( 'ID' => $proxy_id));
			}
			else
			{
				$info =  "Problem z połączeniem. Indeksacja nie została sprawdzona.</br>";
				$wpdb->update($wpdb->prefix."sbart_stats", array('wartosc' => 'brak połączenia'), array( 'ID' => $proxy_id));
			}
		}
		return $info;
	}
?>