<?php

global $sbart_stats_version;
$sbart_stats_version = "1.0";

function sbart_stats_install() 
{
   global $wpdb;
   global $sbart_stats_version;

   $table_name = $wpdb->prefix . "sbart_stats";
      
   $sql = "CREATE TABLE $table_name (
  id mediumint(9) NOT NULL,
  typ VARCHAR(255) DEFAULT '' NOT NULL,
  nazwa VARCHAR(500) DEFAULT '' NOT NULL,
  wartosc VARCHAR(2000) DEFAULT '' NOT NULL,
  czy_wlaczone BOOLEAN NOT NULL DEFAULT '0',
  kolejnosc mediumint(9) NOT NULL,
  UNIQUE KEY id (id))
  CHARACTER SET utf8 COLLATE utf8_general_ci;";
	
	$kto_jest_online_table = $wpdb->prefix . 'kto_jest_online';
	$sql2 = 'CREATE TABLE ' . $kto_jest_online_table . ' (
  ip varchar(100) NOT NULL default \'0\',
  user_id bigint(20) default NULL,
  botname varchar(255) NOT NULL default \'\',
  path varchar(255) NOT NULL default \'\',
  first_visit bigint(20) NULL default NULL,
  last_visit bigint(20) NULL default NULL,
  view_count bigint(20) NOT NULL default \'0\',
  PRIMARY KEY (ip))
  CHARACTER SET utf8 COLLATE utf8_general_ci;';
  
	$sql3= "ALTER TABLE $wpdb->posts ADD google_index BOOLEAN NOT NULL DEFAULT '0'";
	$sql4 = "ALTER TABLE $wpdb->posts ADD google_checked BOOLEAN NOT NULL DEFAULT '0'"; 
	$sql5 = "ALTER TABLE $wpdb->posts ADD google_info BOOLEAN NOT NULL DEFAULT '0'";
	$sql6 = "ALTER TABLE $wpdb->posts ADD google_date DATETIME NOT NULL";
	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	dbDelta($sql);
	dbDelta($sql2);
	$wpdb->query($sql3);
	$wpdb->query($sql4);
	$wpdb->query($sql5); 
	$wpdb->query($sql6);
	add_option("sbart_stats_version", '1.0');
	add_option('kto_jest_online_time_before_off', '5');
	add_option('spolecznosci_google_on_off', '1');
	add_option('spolecznosci_facebook_on_off', '1');
	add_option('spolecznosci_twitter_on_off', '1');
	add_option('czy_sprawdzac_indeksacje', '1');
	add_option('czy_sprawdzac_wyindeksowanie', '1');
	add_option('czy_powiadamiac_o_indeksacji', '1');
	add_option('stan_indeksacji_pozwol_decydowac', '1');
	add_option('stan_indeksacji_zawsze_powiadamiaj', '0');
	add_option('czy_wyswietlac_wszystkim_dashboard_widget', '1');
	add_option('data_sprawdzenia_wersji', '');
	add_option('pokazuj_kolumne_ze_stanem_indeksacji', 1);
}

function sbart_stats_install_data() 
{
	global $wpdb;
	$table_name = $wpdb->prefix . "sbart_stats";
	$wpdb->insert( $table_name, array( 'id' => 0, 'typ' => 'widget-view', 'nazwa' => 'Średni czas indeksacji artykułu', 'wartosc' => 'Średni czas indeksacji', 'czy_wlaczone' => 1, 'kolejnosc' => 4) );
	$wpdb->insert( $table_name, array( 'id' => 1, 'typ' => 'widget-view', 'nazwa' => 'Liczba opublikowanych artykułów', 'wartosc' => 'Opublikowane artykuły', 'czy_wlaczone' => 1, 'kolejnosc' => 1) );
	$wpdb->insert( $table_name, array( 'id' => 2, 'typ' => 'widget-view', 'nazwa' => 'Artykuły oczekujące na akceptację', 'wartosc' => 'Oczekujące na akceptację', 'czy_wlaczone' => 1, 'kolejnosc' => 2) );
	$wpdb->insert( $table_name, array( 'id' => 3, 'typ' => 'widget-view', 'nazwa' => 'Artykuły zaindeksowane przez Google', 'wartosc' => 'Zaindeksowane w Google', 'czy_wlaczone' => 1, 'kolejnosc' => 3 ) );
	$wpdb->insert( $table_name, array( 'id' => 4, 'typ' => 'widget-view', 'nazwa' => 'Liczba zarejestrowanych użytkowników', 'wartosc' => 'Zarejestrowani użytkownicy', 'czy_wlaczone' => 1, 'kolejnosc' => 5 ) );
	$wpdb->insert( $table_name, array( 'id' => 5, 'typ' => 'widget-view', 'nazwa' => 'Liczba komentarzy', 'wartosc' => 'Liczba komentarzy', 'czy_wlaczone' => 1, 'kolejnosc' => 6 ) );
	$wpdb->insert( $table_name, array( 'id' => 6, 'typ' => 'widget-view', 'nazwa' => 'Kto jest online', 'wartosc' => 'Kto jest online', 'czy_wlaczone' => 1, 'kolejnosc' => 7 ) );
	$wpdb->insert( $table_name, array( 'id' => 7, 'typ' => 'widget-view', 'nazwa' => 'Społeczności', 'wartosc' => 'Społeczności', 'czy_wlaczone' => 1, 'kolejnosc' => 8 ) );
	$wpdb->insert( $table_name, array( 'id' => 8, 'typ' => 'mail-zaindeksowane', 'nazwa' => "Artykuł: \"%tytul_artykulu%\" znajduje się już w indeksie Google", 'wartosc' => "%nazwa_uzytkownika%,\n\nZgłoszony przez Ciebie artykuł \"%tytul_artykulu%\" został już zaindeksowany przez wyszukiwarkę Google.\n\nAdres artykułu: %adres_artykul%\n\nPozdrawiam,\nModerator serwisu %nazwa_serwisu%" ) );
	$wpdb->insert( $table_name, array( 'id' => 9, 'typ' => 'mail-wyindeksowane', 'nazwa' => "Artykuł: \"%tytul_artykulu%\"  nie znajduje się już w indeksie Google", 'wartosc' => "%nazwa_uzytkownika%,\n\nZgłoszony przez Ciebie artykuł \"%tytul_artykulu%\" niestety nie znajduje się obecnie w indeksie wyszukiwarki Google.\n\nAdres artykułu: %adres_artykul%\n\nPozdrawiam,\nModerator serwisu %nazwa_serwisu%" ) );
	$wpdb->insert( $table_name, array( 'id' => 10, 'typ' => 'wersja', 'wartosc' => 'YTo0OntzOjY6IndlcnNqYSI7czozOiIxLjAiO3M6OToia29tdW5pa2F0IjtzOjA6IiI7czo1OiJhdXRvciI7czoxNToiaHR0cDovL3NiYXJ0LnBsIjtzOjM6ImFsdCI7czo4OiJzYmFydC5wbCI7fQ==') );
	$wpdb->insert( $table_name, array( 'id' => 11, 'typ' => 'proxy', 'nazwa' => 'localhost', 'wartosc' => 'OK', 'czy_wlaczone' => 1) );
}

function sbart_stats_uninstall()
{
    global $wpdb;
	$table_name = $wpdb->prefix . "sbart_stats";
	$sql = 'DROP TABLE ' . $table_name;
    $wpdb->query($sql);
    $kto_jest_online_table = $wpdb->prefix . 'kto_jest_online';
    $sql = 'DROP TABLE ' . $kto_jest_online_table;
    $wpdb->query($sql);
    delete_option('sbart_stats_version');
	delete_option('kto_jest_online_time_before_off');
	delete_option('spolecznosci_google_on_off');
	delete_option('spolecznosci_facebook_on_off');
	delete_option('spolecznosci_twitter_on_off');
	delete_option('czy_sprawdzac_indeksacje');
	delete_option('czy_sprawdzac_wyindeksowanie');
	delete_option('czy_powiadamiac_o_indeksacji');
	delete_option('stan_indeksacji_pozwol_decydowac');
	delete_option('stan_indeksacji_zawsze_powiadamiaj');
	delete_option('czy_wyswietlac_wszystkim_dashboard_widget');
	delete_option('data_pierwszego_sprawdzenia');
	delete_option('data_sprawdzenia_wersji');
	delete_option('pokazuj_kolumne_ze_stanem_indeksacji');
}

?>