<?php
/*
Plugin Name: SBart stats
Plugin URI: http://sbart.pl/plugin/
Description: Wtyczka pozwla na śledzenie stanu indeksacji w wyszukiwarce Google opublikowanych wpisów oraz na prezentowanie statystyk serwisu. Wtyczka zintegrowana jest pluginem "Who is online" Petera McDonalda, która pozwala śledzić administratorom serwisu kto znajduje się w danej chwili na stronie i jakie teści przegląda.
Author: Bartosz Sikorski
Version: 1.0
Author URI: http://sbart.pl
License: linkware
*/

require_once('database.php');
require_once('widget.php');
require_once('who-is-online.php');
require_once('meta-box.php');
require_once('stan-indeksacji.php');

// Opcje wtyczki


function stan_checbox($parametr)
{
	if($parametr == 1) 
		return "checked=\"checked\"";
	else
		return "";
}

function sbart_plugin_options() 
{
	if (!current_user_can( 'manage_options'))  
	{
		wp_die( __( 'Nie masz uprawnień by korzystać z tej strony.'));
	}
	global $wpdb;
	$table_name = $wpdb->prefix . "sbart_stats";
	if(isset($_POST['zapisz_opcje']) || isset($_POST['dodaj_proxy']))
	{
		if($_POST['czy_sprawdzac_indeksacje'] == 1)
		{
			update_option('czy_sprawdzac_indeksacje', 1);
		}
		else
			update_option('czy_sprawdzac_indeksacje', 0);
			
		if($_POST['czy_sprawdzac_wyindeksowanie'] == 1)
		{
			update_option('czy_sprawdzac_wyindeksowanie', 1);
		}
		else
			update_option('czy_sprawdzac_wyindeksowanie', 0);
			
		if($_POST['kiedy_powiadamiac'] == 0)
		{
			update_option('stan_indeksacji_pozwol_decydowac', 1);
			update_option('stan_indeksacji_zawsze_powiadamiaj', 0);
		}
		else
		{
			update_option('stan_indeksacji_zawsze_powiadamiaj', 1);
			update_option('stan_indeksacji_pozwol_decydowac', 0);
		}
		
		if($_POST['czy_powiadamiac_o_indeksacji'] != 1)
		{
			update_option('czy_powiadamiac_o_indeksacji', 0);
			update_option('stan_indeksacji_zawsze_powiadamiaj', 0);
			update_option('stan_indeksacji_pozwol_decydowac', 0);
		}
		else
			update_option('czy_powiadamiac_o_indeksacji', $_POST['czy_powiadamiac_o_indeksacji']);
			
		$wpdb->update($table_name, array('nazwa' => $_POST['mail_artykul_zaindeksowany'],'wartosc' => $_POST['mail_zaindeksowany_tresc']), array( 'id' => 8));
		$wpdb->update($table_name, array('nazwa' => $_POST['mail_artykul_wyindeksowany'],'wartosc' => $_POST['mail_wyindeksowany_tresc']), array( 'id' => 9));
		
		$serwery_proxy = $wpdb->get_results( "SELECT * FROM $table_name WHERE typ='proxy'" );
		foreach($serwery_proxy as $proxy)
		{
			$wpdb->update($table_name, array('czy_wlaczone' => $_POST[$proxy->id.'_wlwy']), array( 'id' => $proxy->id));
			if($_POST[$proxy->id.'_usun'] == 1)
			{
				$wpdb->query("DELETE FROM $table_name WHERE id=".$proxy->id."");
			}
		}
		
		if($_POST['adres_proxy'] != "http://")
		{
			$ch=curl_init();
			curl_setopt($ch,CURLOPT_URL,$_POST['adres_proxy']."?test=1");
			curl_setopt($ch,CURLOPT_TIMEOUT,10);
			curl_setopt($ch,CURLOPT_CONNECTTIMEOUT, 10);
			curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
			curl_setopt($ch,CURLOPT_HEADER, false);
			curl_setopt($ch,CURLOPT_USERAGENT, 'Opera/9.80 (Windows NT 6.1; U; Edition Campaign 21; pl) Presto/2.6.30 Version/10.61');
			$odpowiedz=curl_exec($ch);
			curl_close($ch);
			if(trim($odpowiedz) == "OK")
			{
				$liczba_rekordow = $wpdb->get_var( "SELECT COUNT(*) FROM $table_name" );
				$wpdb->insert( $table_name, array( 'id' => $liczba_rekordow+1, 'typ' => 'proxy', 'nazwa' => $_POST['adres_proxy'], 'wartosc' => 'OK', 'czy_wlaczone' => 1 ) );
			}
			else
			{
				$komunikat_error = "Pod podanym adresem nie znaleziono pliku proxy.";
			}
		}
		if(!isset($komunikat) && !isset($komunikat_error))
			$komunikat = "Ustawienia zostały zmienione.";
		
	}
	$parametry = unserialize(base64_decode($wpdb->get_var("SELECT wartosc FROM $table_name WHERE id=10")));
	if(czy_nowa_wersja())
	{
		if(isset($parametry['komunikat']) && trim($parametry['komunikat']) != "")
			$parametry['komunikat'] .= "<br/><br/>Dostępna jest nowa wersja wtyczki - <a href=\"http://sbart.pl/wtyczka/\" target=\"_blank\">pobierz</a>";
		else
			$parametry['komunikat'] = "Dostępna jest nowa wersja wtyczki - <a href=\"http://sbart.pl/wtyczka/\" target=\"_blank\">pobierz</a>";
	}
?>
	<div class="wrap">
		<div id="icon-plugins" class="icon32"><br/></div>
		<h2>SBart stats - indeksacja</h2>
		<?php if(isset($parametry['komunikat']) && trim($parametry['komunikat']) != "") { ?>
				<div id="message" class="error">
					<p><?php echo $parametry['komunikat'] ?></p>
				</div>
		<?php } ?>
		<?php if(isset($komunikat_error) && trim($komunikat_error) != "") { ?>
        <div id="message" class="error">
            <p><?php echo $komunikat_error ?></p>
        </div>
        <?php } ?>
		<?php if(isset($komunikat) && trim($komunikat) != "") { ?>
        <div id="message" class="updated">
            <p><?php echo $komunikat ?></p>
        </div>
        <?php } ?>
		<h3>Opcje sprawdzania indeksacji</h3>
		<form name="stats_opcje" method="post">
		<p><input type="checkbox" name="czy_sprawdzac_indeksacje" value="1" <?php echo stan_checbox(get_option('czy_sprawdzac_indeksacje')) ?>> Sprawdzaj czy wpisy oznaczone jako niezaindeksowane pojawiły się w indeksie Google</p>
		<p><input type="checkbox" name="czy_sprawdzac_wyindeksowanie"  value="1" <?php echo stan_checbox(get_option('czy_sprawdzac_wyindeksowanie')) ?>> Sprawdzaj czy wpisy oznaczone jako zaindeksowane nadal znajdują się w indeksie Google</p>
		<h4 style="margin-top:20px;margin-bottom:10px">Lista serwerów</h4>
		<table class="widefat" style="width:60%">
			<thead>
				<tr>
					<th style="text-align:center" scope="col" width="61%">Adres</th>
					<th style="text-align:center" scope="col" width="13%">Stan</th>
					<th style="text-align:center" scope="col" width="13%">Wł./Wy.</th>
					<th style="text-align:center" scope="col" width="13">Usuń</th>
				</tr>
			</thead>
			<tbody>
<?php
	$wynik = $wpdb->get_results("SELECT * FROM $table_name WHERE typ = 'proxy'");
	foreach ( $wynik as $proxy ) 
	{
		if($proxy->id == 11)
		{
			echo "<tr align=\"center\"><td style=\"text-align:left\"><strong>".$proxy->nazwa."</strong></td>\n";
			if($proxy->wartosc == "OK")
				echo "<td style=\"color:green\">".$proxy->wartosc."</td>\n";
			else
				echo "<td style=\"color:red\">".$proxy->wartosc."</td>\n";
			echo "<td><input name=\"".$proxy->id."_wlwy\" type=\"checkbox\"  value=\"1\" ".stan_checbox($proxy->czy_wlaczone)."\"></td>\n";
			echo "<td></td></tr>\n";
		}
		else
		{
			echo "<tr align=\"center\"><td style=\"text-align:left\">".$proxy->nazwa."</td>\n";
			if($proxy->wartosc == "OK")
				echo "<td style=\"color:green\">".$proxy->wartosc."</td>\n";
			else
				echo "<td style=\"color:red\">".$proxy->wartosc."</td>\n";
			echo "<td><input name=\"".$proxy->id."_wlwy\" type=\"checkbox\"  value=\"1\" ".stan_checbox($proxy->czy_wlaczone)."\"></td>\n";
			echo "<td><input name=\"".$proxy->id."_usun\" type=\"checkbox\"  value=\"1\"></td></tr>\n";
		}
	}
?>			
			</tbody>
		</table>
		<p>Dodaj proxy: <input type="text" name="adres_proxy" size="70" value="http://"> <input name="dodaj_proxy" type="submit" value="Dodaj"></p>
		<p style="color:red;font-style:italic">UWAGA: by indeksacja artykułów była sprawdzana należy ustawić zadanie CRON-a na adres: <?php echo get_settings('siteurl'); ?>/wp-content/plugins/sbart-stats/check.php</p>
		<h3 style="margin-top:30px;margin-bottom:10px">Powiadomienia</h3>
		<p><input type="checkbox" name="czy_powiadamiac_o_indeksacji" value="1" <?php echo stan_checbox(get_option('czy_powiadamiac_o_indeksacji')) ?>> Powiadamiaj autorów wpisów o stanie indeksacji</p>
		<div style="margin-left:30px">
			<p><input type="radio" name="kiedy_powiadamiac" value="0" <?php echo stan_checbox(get_option('stan_indeksacji_pozwol_decydowac')) ?>/> Pozwól autorom decydować podczas publikacji danego wpisu</p>
			<p><input type="radio" name="kiedy_powiadamiac" value="1"<?php echo stan_checbox(get_option('stan_indeksacji_zawsze_powiadamiaj')) ?> /> Zawsze powiadamiaj autorów o stanie indeksacji</p>
		</div>
		<h4 style="margin-top:30px;margin-bottom:10px">Szablon wiadomości e-mail: artykuł zaindeksowany</h4>
		<p>Dostępne zmienne: <i>%tytul_artykulu%, %nazwa_uzytkownika%, %adres_artykulu%, %nazwa_serwisu%</i></p>
		<p>Tytuł: <input type="text" name="mail_artykul_zaindeksowany" size="90" value="<?php echo str_replace("\"","&#34", stripslashes($wpdb->get_var("SELECT nazwa FROM $table_name WHERE id = 8" )));?>"></p>
		<p><span style="float:left">Wiadomość:</span>&nbsp;<textarea name="mail_zaindeksowany_tresc" rows="9" cols="90"><?php echo stripslashes($wpdb->get_var( "SELECT wartosc FROM $table_name WHERE id = 8" ));?></textarea></p>
		<h4 style="margin-top:30px;margin-bottom:10px">Szablon wiadomości e-mail: artykuł wyindeksowany</h4>
		<p>Tytuł: <input type="text" name="mail_artykul_wyindeksowany" size="90" value="<?php echo str_replace("\"","&#34", stripslashes($wpdb->get_var( "SELECT nazwa FROM $table_name WHERE id = 9" )));?>"></p>
		<p><span style="float:left">Wiadomość:</span>&nbsp;<textarea name="mail_wyindeksowany_tresc" rows="9" cols="90"><?php echo stripslashes($wpdb->get_var( "SELECT wartosc FROM $table_name WHERE id = 9" ));?></textarea></p>
		<input style="margin:10px" name="zapisz_opcje" type="submit" value="Zapisz zmiany">
		</form>
	</div>
<?php
}

// Link do opcji pluginu

function sbart_stats_settings_link($links) 
{ 
	$settings_link = '<a href="admin.php?page=sbart-stats">Opcje</a>'; 
	array_unshift($links, $settings_link); 
	return $links; 
}

// Dashboard widget

function sbart_stats_add_dashboard_widget()
{
	if(get_option('czy_wyswietlac_wszystkim_dashboard_widget') == 1)
	{
		wp_add_dashboard_widget('sbart_stats_dashboard_widget', __('SBart stats', 'sbart-stats-dwidget'), 'sbart_stats_dashboard_widget');
	}
	else
	{
		include_once( ABSPATH . '/wp-includes/pluggable.php' );
		$user_info = get_userdata(get_current_user_id());
		if($user_info->user_level == 10)
		{
			wp_add_dashboard_widget('sbart_stats_dashboard_widget', __('SBart stats', 'sbart-stats-dwidget'), 'sbart_stats_dashboard_widget');
		}
	}
}
function sbart_stats_dashboard_widget()
{
    global $wpdb;
	$table_name = $wpdb->prefix . "sbart_stats";
	$wynik = $wpdb->get_results("SELECT * FROM $table_name WHERE typ = 'widget-view' ORDER by kolejnosc");
	$widget_content = "<ul style=\"margin-left:10px\">";
	foreach ( $wynik as $rekord ) 
	{
		if($rekord->id == 0 && $rekord->czy_wlaczone == 1)
		{
			$data_pierwszego_sprawdzenia = get_option('data_pierwszego_sprawdzenia');
			$artykuly = $wpdb->get_results( "SELECT * FROM $wpdb->posts WHERE post_status = 'publish' AND google_index=1 AND post_type = 'post' AND post_date > '$data_pierwszego_sprawdzenia'" );
			$godziny = 0;
			foreach($artykuly as $artykul)
			{
				$startdatetime = strtotime($artykul->post_date);
				$enddatetime = strtotime($artykul->google_date);
				$difference = $enddatetime - $startdatetime;
				$godziny = $godziny + $difference/3600;
			}
			if(count($artykuly) != 0)
			{
				$godziny = $godziny / count($artykuly);
				$days = $godziny / 24;
				$minutes = ($godziny - floor($godziny)) * 60; 
				$final_days = round($days,0);
				$final_hours = round($godziny % 24,0);
				$final_minutes = round($minutes);
				if($final_days == 0 && $final_hours != 0)
					$sr_czas = $final_hours . " godz. " . $final_minutes . " min.";
				elseif($final_days == 0 && $final_hours == 0)
					$sr_czas =  $final_minutes . " min.";
				else
					$sr_czas =  $final_days . " d. " . $final_hours . " godz. " . $final_minutes . " min.";
			}
			else
				$sr_czas = "-";
			$widget_content .= "<li>".$rekord->wartosc.": <strong>$sr_czas</strong></li>\n";
		}
		if($rekord->id == 1)
		{
			$opublikowane_artykuly = $wpdb->get_var( "SELECT COUNT(*) FROM $wpdb->posts WHERE post_status = 'publish' AND post_type = 'post'" );
			$widget_content .= "<li>".$rekord->wartosc.": <strong>$opublikowane_artykuly</strong></li>";
		}
		if($rekord->id == 2)
		{
			$oczekujace_na_publikacje = $wpdb->get_var( "SELECT COUNT(*) FROM $wpdb->posts WHERE post_status = 'pending'" );
			$widget_content .= "<li>".$rekord->wartosc.": <strong>$oczekujace_na_publikacje</strong></li>";
		}
		if($rekord->id == 3)
		{
			$opublikowane_artykuly = $wpdb->get_var( "SELECT COUNT(*) FROM $wpdb->posts WHERE post_status = 'publish' AND post_type = 'post'" );
			$zaindeksowane = $wpdb->get_var( "SELECT COUNT(*) FROM $wpdb->posts WHERE google_index = '1' AND post_status = 'publish' AND post_type='post'");
			$procent = round($zaindeksowane / $opublikowane_artykuly * 100,2);
			$widget_content .= "<li>".$rekord->wartosc.": <strong>$zaindeksowane</strong> ($procent%)</li>\n";
		}
		if($rekord->id == 4)
		{
			$liczba_uzytkownikow = $wpdb->get_var("SELECT COUNT(ID) FROM $wpdb->users");
			$widget_content .= "<li>".$rekord->wartosc.": <strong>$liczba_uzytkownikow</strong></li>";
		}
		if($rekord->id == 5 && $rekord->czy_wlaczone == 1)
		{
			$liczba_komentarzy = $wpdb->get_var( "SELECT COUNT(*) FROM $wpdb->comments WHERE comment_approved = '1'" );
			$widget_content .= "<li>".$rekord->wartosc.": <strong>$liczba_komentarzy</strong></li>";
		}
		if($rekord->id == 6)
		{
			
			$kto_jest_online_table = $wpdb->prefix . 'kto_jest_online';
			$guests_sql = 'SELECT COUNT(*) AS user_count FROM ' . $kto_jest_online_table . ' WHERE user_id IS NULL;';
			$members_sql = 'SELECT COUNT(user_id) AS user_count FROM ' . $kto_jest_online_table . ';';
			$result = $wpdb->get_row($members_sql);
			$members = $result->user_count;
			$result2 = $wpdb->get_row($guests_sql);
			$guests = $result2->user_count;
			$widget_content .= "<li>".$rekord->wartosc.": ";
			$widget_content .= sprintf(_n('<strong>%d</strong> użytkownik, ', '<strong>%d</strong> użytkowników, ', $members, 'kto-jest-online'), $members);
			$widget_content .= sprintf(_n('<strong>%d</strong> gość', '<strong>%d</strong> gości', $guests, 'kto-jest-online'), $guests)." <a href=\"admin.php?page=kto-jest-online\" id=kto_jest_online>(zobacz szczegóły)</a></li>";
			
		}
		if($rekord->id == 7)
		{
			$widget_content .= "<li>".$rekord->wartosc.":</li>";
			$widget_content .= "<table cellpadding=\"5px\" ><tr>\n";
			$widget_content .= "<td><script type=\"text/javascript\" src=\"http://apis.google.com/js/plusone.js\">{lang: 'pl'}</script>";
			$widget_content .= "<g:plusone size=\"tall\" href=\"".site_url()."\"></g:plusone></td>\n";
			$widget_content .= "<td><script src=\"http://connect.facebook.net/pl_PL/all.js#xfbml=1\"></script>";
			$widget_content .= "<div class=\"fb-like\" data-href=\"".site_url()."\" data-send=\"false\" data-layout=\"box_count\" data-show-faces=\"true\"></div></td>\n";
			$widget_content .= "<td><a href=\"https://twitter.com/share\" class=\"twitter-share-button\" data-url=\"".site_url()."\" data-via=\"".get_bloginfo( 'name' )."\" data-lang=\"pl\" data-count=\"vertical\">Tweet</a>";
			$widget_content .= "<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0];if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=\"//platform.twitter.com/widgets.js\";fjs.parentNode.insertBefore(js,fjs);}}(document,\"script\",\"twitter-wjs\");</script></td>\n";
			$widget_content .= "</tr></table>\n";
		}
	}
	$widget_content .= "</ul>";
	echo __($widget_content, 'text_domain');
}

// kto jest online lista


function kto_jest_online_display_online_users()
{
	if (!current_user_can( 'manage_options'))  
	{
		wp_die( __( 'Nie masz uprawnień by korzystać z tej strony.'));
	}
    global $wpdb;
    $kto_jest_online_table = $wpdb->prefix . 'kto_jest_online';
    $sql = 'SELECT t1.ip AS ip, ('.time().'-t1.first_visit) AS time_on_site, t1.path, t1.user_id AS user_id, t1.view_count as view_count, t2.display_name AS username, botname FROM ' . $kto_jest_online_table . ' AS t1 LEFT JOIN ' . $wpdb->prefix . 'users AS t2 on t1.user_id = t2.ID WHERE ('.time().'-' . get_option('kto_jest_online_time_before_off') * 60 . ') < last_visit';
    $result = $wpdb->get_results($sql);
	$table_name = $wpdb->prefix . "sbart_stats";
	$parametry = unserialize(base64_decode($wpdb->get_var("SELECT wartosc FROM $table_name WHERE id=10")));
	if(czy_nowa_wersja())
	{
		if(isset($parametry['komunikat']) && trim($parametry['komunikat']) != "")
			$parametry['komunikat'] .= "<br/><br/>Dostępna jest nowa wersja wtyczki - <a href=\"http://sbart.pl/wtyczka/\" target=\"_blank\">pobierz</a>";
		else
			$parametry['komunikat'] = "Dostępna jest nowa wersja wtyczki - <a href=\"http://sbart.pl/wtyczka/\" target=\"_blank\">pobierz</a>";
	}
?>
	<div class="wrap">
	<div id="icon-users" class="icon32"><br /></div>
	<?php if(isset($parametry['komunikat']) && trim($parametry['komunikat']) != "") { ?>
		<div id="message" class="error">
			<p><?php echo $parametry['komunikat'] ?></p>
		</div>
	<?php } ?>
<?php
    echo '<h2>'.__('Użytkownicy online', 'kto-jest-online').'</h2>
<table style="margin-top:10px" class="widefat fixed" cellspacing="0">
<thead>
<tr class="thead">
	<th scope="col" id="username" class="manage-column column-username" width="2%"></th>
	<th scope="col" id="username" class="manage-column column-username" width="6%">'.__('Użytkownicy', 'kto-jest-online').'</th>
	<th scope="col" id="name" class="manage-column column-name" style="text-align:center" width="4%">'.__('IP', 'kto-jest-online').'</th>
	<th scope="col" id="online" class="manage-column column-online" style="text-align:center" width="4%">'.__('Czas na stronie', 'kto-jest-online').'</th>
	<th scope="col" id="views" class="manage-column column-views" style="text-align:center" width="6%">'.__('Odwiedzonych podstron', 'kto-jest-online').'</th>
	<th scope="col" id="role" class="manage-column column-role" style="text-align:center" width="28%">'.__('Obecna podstrona', 'kto-jest-online').'</th>
</tr>
</thead>
<tfoot>
<tr class="thead">
	<th scope="col" id="username" class="manage-column column-username"></th>
	<th scope="col" id="username" class="manage-column column-username">'.__('Użytkownicy', 'kto-jest-online').'</th>
	<th scope="col" id="name" class="manage-column column-name" style="text-align:center">'.__('IP', 'kto-jest-online').'</th>
	<th scope="col" id="online" class="manage-column column-online" style="text-align:center">'.__('Czas na stronie', 'kto-jest-online').'</th>
	<th scope="col" id="views" class="manage-column column-views" style="text-align:center">'.__('Odwiedzonych podstron', 'kto-jest-online').'</th>
	<th scope="col" id="role" class="manage-column column-role" style="text-align:center">'.__('Obecna podstrona', 'kto-jest-online').'</th>
</tr>
</tfoot>
<tbody id="users" class="list:user user-list">
';
    if($result)
    {
        foreach($result as $visitor)
        {
            if(!empty($visitor->botname))
            {
                $username = attribute_escape($visitor->botname);
            }
            elseif(!is_null($visitor->username))
            {
                $username = '<a href="user-edit.php?user_id=' . attribute_escape($visitor->user_id) . '">' . attribute_escape($visitor->username) . '</a>';
            }
            else
            {
                $username = __('Gość', 'kto-jest-online');
            }
            echo '<tr id=\'user-2\' class="alternate">
<td style="padding-left:20px"><img alt=\'\' src=\'http://www.gravatar.com/avatar/afa3d41f09219ba903e58f96a13eb5cd?s=32&amp;d=http%3A%2F%2Fwww.gravatar.com%2Favatar%2Fad516503a11cd5ca435acc9bb6523536%3Fs%3D32&amp;r=G\' class=\'avatar avatar-32 photo\' width=\'32\' /> </td>
<td class="username column-username" style="vertical-align:middle"><strong>' . $username . '</span></strong></td>
<td class="ip column-ip" style="text-align:center;vertical-align:middle"><a href="http://whois.domaintools.com/' . $visitor->ip . '" target="_blank">' . $visitor->ip . '</a></td>
<td class="online column-online" style="text-align:center;vertical-align:middle">' . kto_jest_online_time_convert($visitor->time_on_site) . '</td>
<td class="online column-online" style="text-align:center;vertical-align:middle">' . $visitor->view_count . '</td>
<td class="viewing column-viewing" style="padding-left:60px;vertical-align:middle"><a href="' . attribute_escape($visitor->path) . '">' . attribute_escape($visitor->path) . '</a></td>
</tr>
';
        }
    }
    echo '</table>';
}

function sbart_widgets_options()
{
	if (!current_user_can( 'manage_options'))  
	{
		wp_die( __( 'Nie masz uprawnień by korzystać z tej strony.'));
	}
	global $wpdb;
	$table_name = $wpdb->prefix . "sbart_stats";
	if(isset($_POST['zapisz_opcje']))
	{
		if($_POST['czy_wyswietlac_wszystkim_dashboard_widget'] == 1)
		{
			update_option('czy_wyswietlac_wszystkim_dashboard_widget', 1);
		}
		else
			update_option('czy_wyswietlac_wszystkim_dashboard_widget', 0);
			
		if($_POST['pokazuj_kolumne_ze_stanem_indeksacji'] == 1)
		{
			update_option('pokazuj_kolumne_ze_stanem_indeksacji', 1);
		}
		else
			update_option('pokazuj_kolumne_ze_stanem_indeksacji', 0);
			
		if($_POST['7_widocznosc_google'] == 1)
		{
			update_option('spolecznosci_google_on_off', 1);
		}
		else
			update_option('spolecznosci_google_on_off', 0);
			
		if($_POST['7_widocznosc_facebook'] == 1)
		{
			update_option('spolecznosci_facebook_on_off', 1);
		}
		else
			update_option('spolecznosci_facebook_on_off', 0);
		
		if($_POST['7_widocznosc_twitter'] == 1)
		{
			update_option('spolecznosci_twitter_on_off', 1);
		}
		else
			update_option('spolecznosci_twitter_on_off', 0);
			
		for($i=0;$i<8;$i++)
		{
			$wpdb->update($table_name, array('wartosc' => $_POST[$i.'_wartosc'],'kolejnosc' => $_POST[$i.'_kolejnosc'], 'czy_wlaczone' => $_POST[$i.'_widocznosc']), array( 'id' => $i));
		}
		
		$komunikat = "Ustawienia zostały zmienione.";
	}
	$parametry = unserialize(base64_decode($wpdb->get_var("SELECT wartosc FROM $table_name WHERE id=10")));
	if(czy_nowa_wersja())
	{
		if(isset($parametry['komunikat']) && trim($parametry['komunikat']) != "")
			$parametry['komunikat'] .= "<br/><br/>Dostępna jest nowa wersja wtyczki - <a href=\"http://sbart.pl/wtyczka/\" target=\"_blank\">pobierz</a>";
		else
			$parametry['komunikat'] = "Dostępna jest nowa wersja wtyczki - <a href=\"http://sbart.pl/wtyczka/\" target=\"_blank\">pobierz</a>";
	}
?>
	<div id="icon-plugins" class="icon32"><br/></div>
	<div class="wrap">
	<h2>SBart stats - widgety</h2>
	<?php if(isset($parametry['komunikat']) && trim($parametry['komunikat']) != "") { ?>
		<div id="message" class="error">
			<p><?php echo $parametry['komunikat'] ?></p>
		</div>
	<?php } ?>
	<?php if(isset($komunikat) && trim($komunikat) != "") { ?>
	<div id="message" class="updated">
		<p><?php echo $komunikat ?></p>
	</div>
	<?php } ?>
	<h3>Opcje widget-u</h3>
	<form method="post">
	<p><input type="checkbox" name="czy_wyswietlac_wszystkim_dashboard_widget" value="1" <?php echo stan_checbox(get_option('czy_wyswietlac_wszystkim_dashboard_widget')) ?>> Wyświetlaj widget w kokpicie wszystkim użytkownikom</p>
	<p><input type="checkbox" name="pokazuj_kolumne_ze_stanem_indeksacji" value="1" <?php echo stan_checbox(get_option('pokazuj_kolumne_ze_stanem_indeksacji')) ?>> Wyświetlaj kolumnę ze stanem indeksacji w tabeli z listą artykułów.</p>
	<p><i>UWAGA: by widget wyświetlał się na podstronach serwisu należy go aktywować <a href="widgets.php">tutaj</a></i></p>
	<h4 style="margin-top:20px;margin-bottom:10px">Edycja pól</h4>
	<table class="widefat" style="width:60%">
		<thead>
			<tr>
				<th style="text-align:center" scope="col">Pole</th>
				<th style="text-align:center" scope="col">Wyświetlany tekst</th>
				<th style="text-align:center" scope="col">Kolejność</th>
				<th style="text-align:center" scope="col">Widoczność</th>
			</tr>
		</thead>
		<tbody>
		
		
<?php
	$wynik = $wpdb->get_results("SELECT * FROM $table_name WHERE typ = 'widget-view' ORDER by kolejnosc");
	foreach ( $wynik as $rekord ) 
	{
			echo "<tr><td style=\"vertical-align: middle;\"><strong>".$rekord->nazwa."</strong></td>\n";
			echo "<td align=\"center\"><input name=\"".$rekord->id."_wartosc\" type=\"text\" size=\"35\" value=\"".$rekord->wartosc."\"></td>\n";
			echo "<td align=\"center\"><input name=\"".$rekord->id."_kolejnosc\" style=\"text-align:center\" type=\"text\" value=\"".$rekord->kolejnosc."\" size=\"1\"></td>\n";
			
			echo "<td style=\"vertical-align: middle;\" align=\"center\"><input name=\"".$rekord->id."_widocznosc\" type=\"checkbox\" value=\"1\" ".stan_checbox($rekord->czy_wlaczone).">";
			if($rekord->id == 7)
			{
				echo "<div style=\"margin-left:7px;display:inline\">G<input name=\"".$rekord->id."_widocznosc_google\" type=\"checkbox\" value=\"1\" ".stan_checbox(get_option('spolecznosci_google_on_off'))."> F<input name=\"".$rekord->id."_widocznosc_facebook\" type=\"checkbox\" value=\"1\" ".stan_checbox(get_option('spolecznosci_facebook_on_off'))."> T<input name=\"".$rekord->id."_widocznosc_twitter\" type=\"checkbox\" value=\"1\" ".stan_checbox(get_option('spolecznosci_twitter_on_off'))."></div>";
			}
			echo "</td></tr>";
	}
?>
		</tbody>
	</table>
	<h3 style="margin-top:30px">Zmienna do szablonu</h3>
	<p>Aby wyświetlać w artykule lub w pętli artykułów stan indeksacji danego wpisu, należy wstawić do szablonu następujący kod:</p>
	<p><i><pre>&lt?php echo do_shortcode("[stan_indeksacji]"); ?&gt</pre></i></p>
	<p>Funkcja zwraca "Tak" jeśli artykuł jest zaindekosowany w Google, w przeciwnym wypadku zwraca "Nie".</p>
	<input style="margin:10px" name="zapisz_opcje" type="submit" value="Zapisz zmiany">
	</form>
	</div>
<?php
}

function sprawdz_wersje()
{
	$aktualna_data = date("Y-m-d");
	if(get_option('data_sprawdzenia_wersji') != $aktualna_data)
	{
		update_option('data_sprawdzenia_wersji',$aktualna_data);
		//sprawdzamy czy jest nowa wersja wtyczki
		
		$blog = str_replace("=","",base64_encode(get_settings('siteurl')));
		ini_set('display_errors', 'Off');
		ini_set('display_startup_errors', 'Off');
		error_reporting(0);
		$xml_parse = simplexml_load_file("http://sbart.pl/sbart-stats/".$blog.".xml");
		
		$dane = $xml_parse->parametr;
		$tablica = "";
		foreach ($dane AS $parametr_index => $parametr_obj)
		{
			$tablica['wersja'] = strval($parametr_obj->wersja);
			$tablica['komunikat'] = strval($parametr_obj->komunikat);
			$tablica['autor'] = strval($parametr_obj->autor);
			$tablica['alt'] = strval($parametr_obj->alt);
		}
		global $wpdb;
		$table_name = $wpdb->prefix . "sbart_stats";
		$wpdb->update($table_name, array('wartosc' => base64_encode(serialize($tablica))), array( 'id' => 10));
	}
}
function czy_nowa_wersja()
{
	global $wpdb;
	$table_name = $wpdb->prefix . "sbart_stats";
	$tabela = unserialize(base64_decode($wpdb->get_var("SELECT wartosc FROM $table_name WHERE id=10")));
	if(get_option('sbart_stats_version') != $tabela['wersja'])
	{
		return true;
	}
	else
		return false;
}

// kolumna w tabeli postow
function naglowek_kolumny($defaults) 
{  
    $defaults['stan_indeksacji'] = 'W google';  
    return $defaults;  
}  
  
// kolumna w tabeli postow - zawartość
function zawartosc_kolumny($column_name, $post_id) 
{  
    if ($column_name == 'stan_indeksacji') 
	{
		global $wpdb;
		$stan_indeksacji = $wpdb->get_var("SELECT google_index FROM $wpdb->posts WHERE id='$post_id'");
		if($stan_indeksacji == 1)
			echo "Tak";
		else
			echo "Nie";
    }  
}

// zmienna do szablonu
function szablon_stan_indeksacji() 
{
	global $post;
	global $wpdb;
	$post_id = $post->ID;
	$stan_indeksacji = $wpdb->get_var("SELECT google_index FROM $wpdb->posts WHERE id='$post_id'");
	if($stan_indeksacji == 1)
		echo "Tak";
	else
		echo "Nie";
}


//instalacja wtyczki
register_activation_hook(__FILE__,'sbart_stats_install');
register_activation_hook(__FILE__,'sbart_stats_install_data');

//usuwanie wtyczki
register_deactivation_hook(__FILE__, 'sbart_stats_uninstall');

//menu wtyczki
function sbart_stats_menu () 
{
	add_menu_page('SBart Admin','SBart stats','manage_options', 'sbart-stats', 'sbart_plugin_options','/wp-content/plugins/sbart-stats/icon.png');
}
add_action('admin_menu','sbart_stats_menu');

//podstrony w menu
function opcje_indeksacji_menu() 
{
	add_submenu_page( 'sbart-stats', 'Indeksacja', 'Opcje indeksacji', 'manage_options', 'sbart-stats', 'sbart_plugin_options' );
}
add_action('admin_menu', 'opcje_indeksacji_menu');

function stan_indeksacji_menu() 
{
	add_submenu_page( 'sbart-stats', 'Stan indeksacji', 'Stan indeksacji', 'manage_options', 'sbart-stats-stan-indeksacji', 'sbart_stan_indeksacji' );
}
add_action('admin_menu', 'stan_indeksacji_menu');

function widgety_menu() 
{
	add_submenu_page( 'sbart-stats', 'Widgety', 'Widgety', 'manage_options', 'sbart-stats-widgety', 'sbart_widgets_options' );
}
add_action('admin_menu', 'widgety_menu');

function kto_jest_online_menu()
{
	add_submenu_page( 'sbart-stats', 'Kto jest online', 'Kto jest online', 'manage_options', 'kto-jest-online', 'kto_jest_online_display_online_users' ); 
}
add_action('admin_menu', 'kto_jest_online_menu');

// dodaj widget
add_action('widgets_init', create_function('', 'register_widget("sbart_stats_widget");'));

// dodaj dashboard widget
add_action('wp_dashboard_setup', 'sbart_stats_add_dashboard_widget');

// sprawdzaj kto jest online
add_action('get_header', 'kto_jest_online_upload_activity');
add_action('admin_head', 'kto_jest_online_upload_activity');
add_filter('the_author', 'kto_jest_online_autor');
// sprawdzanie aktualnej wersji
sprawdz_wersje();

if(get_option('czy_powiadamiac_o_indeksacji') == 1 && get_option('stan_indeksacji_pozwol_decydowac') == 1)
{
	// dodaj box przy publikacji artykułu
	add_action( 'add_meta_boxes', 'indeksacja_add_custom_box' );
	// uaktualnij ustawienia przy zapisie artykułu
	add_action( 'save_post', 'indeksacja_save_postdata' );
}

// dodaj link do opcji wtyczki
$plugin = plugin_basename(__FILE__); 
add_filter("plugin_action_links_$plugin", 'sbart_stats_settings_link' );

// dodaj kolumne do tabeli postów
if(get_option('pokazuj_kolumne_ze_stanem_indeksacji') == 1)
{
	add_filter('manage_posts_columns', 'naglowek_kolumny');  
	add_action('manage_posts_custom_column', 'zawartosc_kolumny', 10, 2);
}

// dodaj zmienna do szablonu
add_shortcode('stan_indeksacji', 'szablon_stan_indeksacji');
?>