<?php

if(!class_exists('WP_List_Table')){
    require_once( ABSPATH . 'wp-admin/includes/class-wp-list-table.php' );
}
//if($_GET['page'] == "sbart-stats-stan-indeksacji")
//{
	add_action( 'admin_head', 'add_css' );
//}

function add_css() 
{ 
	$width = '<style type="text/css">';
	if($_GET['page'] == "sbart-stats-stan-indeksacji")
	{
		$width .= '.wp-list-table .column-post_title { width: 35%; }';
		if($_GET['stan'] == "zaindeksowane" || $_GET['stan'] == "niezaindeksowane")
		{
			$width .= '.wp-list-table .column-post_category { width: 12%; }';
			$width .= '.wp-list-table .column-google_index { width: 14%;text-align:center }';
			$width .= '.wp-list-table .column-post_author { width: 11%; }';
		}
		else
		{
			$width .= '.wp-list-table .column-post_author { width: 12%; }';
			$width .= '.wp-list-table .column-post_category { width: 15%; }';
			$width .= '.wp-list-table .column-google_index { width: 10%;text-align:center }';
		}
			$width .= '.wp-list-table .column-post_date { width: 14%; }';
			$width .= '.wp-list-table .column-google_info { width: 14%;text-align:center }';
			$width .= '.tablenav { clear: none }';
			$width .= 'ul.subsubsub li { color: #555 }';
			$width .= '.row-actions { float: none }';
			$width .= '.row-actions span{ color: #555 }';
	}
	$width .= '.wp-list-table .column-stan_indeksacji{ width: 100px;text-align:center }';
	$width .= '</style>';
	echo $width;
}
		
 
class TT_Example_List_Table extends WP_List_Table {
 
    function __construct(){
        global $status, $page;
        
        parent::__construct( array(
            'singular'  => 'wpis',
            'plural'    => 'wpisy',
            'ajax'      => false
        ) );
        
    }
	
	function column_default($item, $column_name){
        switch($column_name){
            case 'post_author':
				$user_info = get_userdata($item['post_author']);
				return $user_info->user_login;
			case 'post_category':
				return $item[$column_name];
            case 'post_date':
                return $item[$column_name];
            default:
                return print_r($item,true);
        }
    }
  
    function column_post_title($item){
        
		$url = get_permalink($item['ID']);
		$url = str_replace("http://", "",$url);
		$url = str_replace("https://", "",$url);
		if(substr($url, 0, 4) == "www.") $url = str_replace("www.", "",$url);

        $actions = array(
            'pinguj'      => sprintf('<a href="javascript:document.getElementById(\'ping\').value = \'%s\';document.forms[\'akcja\'].submit();">Pinguj</a>', $item['ID']),
            'sprawdz'    => sprintf('<a href="javascript:document.getElementById(\'sprawdz\').value = \'%s\';document.forms[\'akcja\'].submit();">Sprawdź indeksację</a>', $item['ID']),
			'google'    => 'Google: <a href="http://www.google.pl/search?hl=pl&q=site:'.$url.'" target="_blank">site:</a> <a href="http://www.google.pl/search?hl=pl&q=inurl:'.$url.'" target="_blank">inurl:</a>',
        );
		 
        return '<a class="row-title" href="'.get_permalink($item['ID']).'">'.$item['post_title'].'</a>'.$this->row_actions($actions);
    }
	
	function column_google_index($item)
	{     
        if($_GET['stan'] == "zaindeksowane")
		{
			$startdatetime = strtotime($item['post_date']);
			$enddatetime = strtotime($item['google_date']);
			if($startdatetime > strtotime(get_option('data_pierwszego_sprawdzenia')))
			{
				$difference = $enddatetime - $startdatetime; 
				$hours = $difference / 3600;
				$days = $hours / 24;
				$minutes = ($hours - floor($hours)) * 60; 
				$final_days = round($days,0);
				$final_hours = round($hours % 24,0);
				$final_minutes = round($minutes);
				if($final_days == 0  && $final_hours != 0)
					return $final_hours . " godz. " . $final_minutes . " min.";
				if($final_days == 0 && $final_hours == 0)
					return $final_minutes . " min.";
				else
					return $final_days . " d. " . $final_hours . " godz. " . $final_minutes . " min.";
			}
			else
			{
				return "-";
			}
		}
		elseif($_GET['stan'] == "niezaindeksowane")
		{
			$startdatetime = strtotime($item['post_date']);
			$enddatetime = strtotime(date("Y-m-d H:i:s"));
			$difference = $enddatetime - $startdatetime; 
			$hours = $difference / 3600;
			$days = $hours / 24;
			$minutes = ($hours - floor($hours)) * 60; 
			$final_days = round($days,0);
			$final_hours = round($hours % 24,0);
			$final_minutes = round($minutes);
			if($final_days == 0  && $final_hours != 0)
				return $final_hours . " godz. " . $final_minutes . " min.";
			if($final_days == 0 && $final_hours == 0)
				return $final_minutes . " min.";
			else
				return $final_days . " d. " . $final_hours . " godz. " . $final_minutes . " min.";
		}
		else
		{
			if($item['google_index'] == 1)
				$indeksacja = "<span style=\"color: green\">TAK<span>";
			else
				$indeksacja = "<span style=\"color: red\">NIE<span>";
			return $indeksacja;
		}
    }
    
	function column_google_info($item)
	{     
		if($item['google_info'] == 1)
			$powiadomienia = "TAK";
		else
			$powiadomienia = "NIE";
        return $powiadomienia;
    }
	
    function get_columns(){
		if($_GET['stan'] == "zaindeksowane")
			$google_index = "CZAS INDEKSACJI";
		elseif($_GET['stan'] == "niezaindeksowane")
			$google_index = "OD PUBLIKACJI";
		else
			$google_index = "W GOOGLE";
			
        $columns = array(
            'post_title'     => 'TYTUŁ',
            'post_author'    => 'AUTOR',
			'post_category'  => 'KATEGORIA',
            'post_date'  => 'DATA PUBLIKACJI',
			'google_index'  => $google_index,
			'google_info'  => 'POWIADOMIENIA'
        );
        return $columns;
    }
    
    function get_sortable_columns() {
        $sortable_columns = array(
            'post_title'     => array('post_title',true),
            'post_author'    => array('post_author',false),
			'post_category'    => array('post_category',false),
            'post_date'  => array('post_date',false),
			'google_index'  => array('google_index',false),
			'google_info'  => array('google_info',false)
        );
        return $sortable_columns;
    } 

    function prepare_items() 
	{
        $per_page = 15;
        
        $columns = $this->get_columns();
        $hidden = array();
        $sortable = $this->get_sortable_columns();
        
        $this->_column_headers = array($columns, $hidden, $sortable);

		global $wpdb;
		if($_GET['stan'] == "zaindeksowane")
			$data = $wpdb->get_results("SELECT ID,post_title,post_author,post_date,google_index,google_info,google_date,post_date FROM $wpdb->posts WHERE post_status='publish' AND post_type='post' AND google_index = 1",'ARRAY_A');
		elseif($_GET['stan'] == "niezaindeksowane")
			$data = $wpdb->get_results("SELECT ID,post_title,post_author,post_date,google_index,google_info FROM $wpdb->posts WHERE post_status='publish' AND post_type='post' AND google_index = 0",'ARRAY_A');
		else
			$data = $wpdb->get_results("SELECT ID,post_title,post_author,post_date,google_index,google_info FROM $wpdb->posts WHERE post_status='publish' AND post_type='post' ORDER BY post_date DESC",'ARRAY_A');
		
		$i=0;
		foreach($data as $single)
		{
			$category = get_the_category($single['ID']);
			$data[$i]['post_category'] = $category[0]->cat_name;
			$i++;
		}
		
        function usort_reorder($a,$b){
            $orderby = (!empty($_REQUEST['orderby'])) ? $_REQUEST['orderby'] : 'post_date';
            $order = (!empty($_REQUEST['order'])) ? $_REQUEST['order'] : 'desc';
            $result = strcmp($a[$orderby], $b[$orderby]);
            return ($order==='asc') ? $result : -$result;
        }
        usort($data, 'usort_reorder');
        
        $current_page = $this->get_pagenum();
        
        $total_items = count($data);
      
        $data = array_slice($data,(($current_page-1)*$per_page),$per_page);
   
        $this->items = $data;

        $this->set_pagination_args( array(
            'total_items' => $total_items,
            'per_page'    => $per_page,
            'total_pages' => ceil($total_items/$per_page)
        ) );
    }
    
}

function sbart_weblog_ping($service, $post_id)
{
	global $wp_version;
	include_once(ABSPATH . WPINC . '/class-IXR.php');
	include_once(ABSPATH . WPINC . '/class-wp-http-ixr-client.php');

	$client = new WP_HTTP_IXR_Client("http://rpc.pingomatic.com/", ((!strlen(trim($path)) || ('/' == $path)) ? false : $path));
	$client->timeout = 3;
	$client->useragent .= ' -- WordPress/'.$wp_version;

	$client->debug = false;
	$client->query('weblogUpdates.extendedPing', get_the_title($post_id), get_permalink($post_id), "", get_bloginfo('rss2_url') );
}

function sbart_generic_ping($post_id) {
	$services = get_option('ping_sites');

	$services = explode("\n", $services);
	foreach ( (array) $services as $service ) {
		$service = trim($service);
		if ( '' != $service )
			sbart_weblog_ping($service, $post_id);
	}
}

function sbart_stan_indeksacji()
{
	global $wpdb;
	$table_name = $wpdb->prefix . "sbart_stats";
	if(isset($_POST['ping']) && trim($_POST['ping']) != "")
	{
		sbart_generic_ping($_POST['ping']);
		$komunikat = "Adres <strong>".get_permalink($_POST['ping'])."</strong> został zgłoszony do serwisów znadjujących się na tej <a href=\"options-writing.php\">liście</a>.";
	}
	if(isset($_POST['sprawdz']) && trim($_POST['sprawdz']) != "")
	{
		require_once('check.php');
		$post_id = $_POST['sprawdz'];
		//sprawdz indeksację na rządanie
		$komunikat = sprawdz_indeksacje(3,losuj_proxy(),$post_id);
	}
    $testListTable = new TT_Example_List_Table();
    $testListTable->prepare_items();
	
	$l_wszystkich_artykulow = $wpdb->get_var("SELECT COUNT(*) FROM $wpdb->posts WHERE post_status='publish' AND post_type='post'");
	$l_zaindeksowanych_artykulow = $wpdb->get_var("SELECT COUNT(*) FROM $wpdb->posts WHERE post_status='publish' AND post_type='post' AND google_index = 1");
	$l_niezaindeksowanych_artykulow = $wpdb->get_var("SELECT COUNT(*) FROM $wpdb->posts WHERE post_status='publish' AND post_type='post' AND google_index = 0");
	$parametry = unserialize(base64_decode($wpdb->get_var("SELECT wartosc FROM $table_name WHERE id=10")));
	if(czy_nowa_wersja())
	{
		if(isset($parametry['komunikat']) && trim($parametry['komunikat']) != "")
			$parametry['komunikat'] .= "<br/><br/>Dostępna jest nowa wersja wtyczki - <a href=\"http://sbart.pl/wtyczka/\" target=\"_blank\">pobierz</a>";
		else
			$parametry['komunikat'] = "Dostępna jest nowa wersja wtyczki - <a href=\"http://sbart.pl/wtyczka/\" target=\"_blank\">pobierz</a>";
	}
   ?>
    <div class="wrap">
        <div id="icon-plugins" class="icon32"><br/></div>
        <h2>SBart stats - stan indeksacji</h2>
        <?php if(isset($parametry['komunikat']) && trim($parametry['komunikat']) != "") { ?>
			<div id="message" class="error">
				<p><?php echo $parametry['komunikat'] ?></p>
			</div>
		<?php } ?>
		<?php if(isset($komunikat) && trim($komunikat) != "") { ?>
        <div id="message" class="updated">
            <p><?php echo $komunikat ?></p>
        </div>
        <?php } ?>
		<ul class='subsubsub' style="float:left">
			<li><a href="admin.php?page=<?php echo $_REQUEST['page'] ?>" <?php if($_GET['stan']!="zaindeksowane" && $_GET['stan']!="niezaindeksowane") echo 'class="current"' ?>>Wszystkie</a> (<?php echo $l_wszystkich_artykulow ?>) |</li>
			<li><a href="admin.php?page=<?php echo $_REQUEST['page'] ?>&stan=zaindeksowane" <?php if($_GET['stan']=="zaindeksowane") echo 'class="current"' ?>>Zaindeksowane</a> (<?php echo $l_zaindeksowanych_artykulow ?>) |</li>
			<li><a href="admin.php?page=<?php echo $_REQUEST['page'] ?>&stan=niezaindeksowane" <?php if($_GET['stan']=="niezaindeksowane") echo 'class="current"' ?>>Niezaindeksowane</a> (<?php echo $l_niezaindeksowanych_artykulow ?>)</li>
		</ul>
		
		<form name="akcja" method="POST">
			<input type="hidden" id="ping" name="ping">
			<input type="hidden" id="sprawdz" name="sprawdz">
		</form>
        <form id="movies-filter" method="get">
            <input type="hidden" name="page" value="<?php echo $_REQUEST['page'] ?>" />
            <?php $testListTable->display() ?>
        </form>
       
    </div>
<?php } ?>