<?php

class sbart_stats_widget extends WP_Widget {

	public function __construct() 
	{
		parent::__construct(
	 		'sbart_stats_widget',
			'SBart Stats',
			array('description' => __('Statystyki artykułów, użytkowników oraz działań społecznościowych.', 'text_domain'),)
		);
	}

	public function widget($args, $instance) 
	{
		extract($args);
		$title = apply_filters( 'widget_title', $instance['title']);
		
		echo $before_widget;
		if (!empty( $title ))
			echo $before_title . $title . $after_title."\n";
		
		global $wpdb;
		$table_name = $wpdb->prefix . "sbart_stats";
		$wynik = $wpdb->get_results("SELECT * FROM $table_name WHERE typ = 'widget-view' ORDER by kolejnosc");
		$widget_content = "<ul>\n";
		foreach ( $wynik as $rekord ) 
		{
			if($rekord->id == 0 && $rekord->czy_wlaczone == 1)
			{
				$data_pierwszego_sprawdzenia = get_option('data_pierwszego_sprawdzenia');
				$artykuly = $wpdb->get_results( "SELECT * FROM $wpdb->posts WHERE post_status = 'publish' AND post_type = 'post' AND google_index=1 AND post_date > '$data_pierwszego_sprawdzenia'" );
				$godziny = 0;
				foreach($artykuly as $artykul)
				{
					$startdatetime = strtotime($artykul->post_date);
					$enddatetime = strtotime($artykul->google_date);
					$difference = $enddatetime - $startdatetime;
					$godziny = $godziny + $difference/3600;
				}
				if(count($artykuly) != 0)
				{
					$godziny = $godziny / count($artykuly);
					$days = $godziny / 24;
					$minutes = ($godziny - floor($godziny)) * 60; 
					$final_days = round($days,0);
					$final_hours = round($godziny % 24,0);
					$final_minutes = round($minutes);
					if($final_days == 0 && $final_hours != 0)
						$sr_czas = $final_hours . " godz. " . $final_minutes . " min.";
					elseif($final_days == 0 && $final_hours == 0)
						$sr_czas =  $final_minutes . " min.";
					else
						$sr_czas =  $final_days . " d. " . $final_hours . " godz. " . $final_minutes . " min.";
				}
				else
					$sr_czas = "-";
				$widget_content .= "<li>".$rekord->wartosc.": <strong>$sr_czas</strong></li>\n";
			}
			if($rekord->id == 1 && $rekord->czy_wlaczone == 1)
			{
				$opublikowane_artykuly = $wpdb->get_var( "SELECT COUNT(*) FROM $wpdb->posts WHERE post_status = 'publish' AND post_type = 'post'" );
				$widget_content .= "<li>".$rekord->wartosc.": <strong>$opublikowane_artykuly</strong></li>\n";
			}
			if($rekord->id == 2 && $rekord->czy_wlaczone == 1)
			{
				$oczekujace_na_publikacje = $wpdb->get_var( "SELECT COUNT(*) FROM $wpdb->posts WHERE post_status = 'pending'" );
				$widget_content .= "<li>".$rekord->wartosc.": <strong>$oczekujace_na_publikacje</strong></li>\n";
			}
			if($rekord->id == 3 && $rekord->czy_wlaczone == 1)
			{
				$opublikowane_artykuly = $wpdb->get_var( "SELECT COUNT(*) FROM $wpdb->posts WHERE post_status = 'publish' AND post_type = 'post'" );
				$zaindeksowane = $wpdb->get_var( "SELECT COUNT(*) FROM $wpdb->posts WHERE google_index = '1' AND post_status = 'publish' AND post_type='post'");
				$procent = round($zaindeksowane / $opublikowane_artykuly * 100,2);
				$widget_content .= "<li>".$rekord->wartosc.": <strong>$zaindeksowane</strong> ($procent%)</li>\n";
			}
			if($rekord->id == 4 && $rekord->czy_wlaczone == 1)
			{
				$liczba_uzytkownikow = $wpdb->get_var("SELECT COUNT(ID) FROM $wpdb->users");
				$widget_content .= "<li>".$rekord->wartosc.": <strong>$liczba_uzytkownikow</strong></li>\n";
			}
			if($rekord->id == 5 && $rekord->czy_wlaczone == 1)
			{
				$liczba_komentarzy = $wpdb->get_var( "SELECT COUNT(*) FROM $wpdb->comments WHERE comment_approved = '1'" );
				$widget_content .= "<li>".$rekord->wartosc.": <strong>$liczba_komentarzy</strong></li>\n";
			}
			if($rekord->id == 6 && $rekord->czy_wlaczone == 1)
			{
				
				$kto_jest_online_table = $wpdb->prefix . 'kto_jest_online';
				$guests_sql = 'SELECT COUNT(*) AS user_count FROM ' . $kto_jest_online_table . ' WHERE user_id IS NULL;';
				$members_sql = 'SELECT COUNT(user_id) AS user_count FROM ' . $kto_jest_online_table . ';';
				$result = $wpdb->get_row($members_sql);
				$members = $result->user_count;
				$result2 = $wpdb->get_row($guests_sql);
				$guests = $result2->user_count;
				$widget_content .= "<li>".$rekord->wartosc.": ";
				$widget_content .= sprintf(_n('<strong>%d</strong> użytkownik, ', '<strong>%d</strong> użytkowników, ', $members, 'kto-jest-online'), $members);
				$widget_content .= sprintf(_n('<strong>%d</strong> gość', '<strong>%d</strong> gości', $guests, 'kto-jest-online'), $guests)."</li>\n";
				
			}
			if($rekord->id == 7 && $rekord->czy_wlaczone == 1)
			{
				$widget_content .= "<li>".$rekord->wartosc.":</li>\n";
				$widget_content .= "<table><tr>\n";
				if(get_option('spolecznosci_google_on_off') == 1)
				{
					$widget_content .= "<td style=\"padding:4px\"><script type=\"text/javascript\" src=\"http://apis.google.com/js/plusone.js\">{lang: 'pl'}</script>";
					$widget_content .= "<g:plusone size=\"tall\" href=\"".site_url()."\"></g:plusone></td>\n";
				}
				if(get_option('spolecznosci_facebook_on_off') == 1)
				{
					$widget_content .= "<td style=\"padding:4px\"><script src=\"http://connect.facebook.net/pl_PL/all.js#xfbml=1\"></script>";
					$widget_content .= "<div class=\"fb-like\" data-href=\"".site_url()."\" data-send=\"false\" data-layout=\"box_count\" data-show-faces=\"true\"></div></td>\n";
				}
				if(get_option('spolecznosci_twitter_on_off') == 1)
				{
					$widget_content .= "<td style=\"padding:4px\"><a href=\"https://twitter.com/share\" class=\"twitter-share-button\" data-url=\"".site_url()."\" data-via=\"".get_bloginfo( 'name' )."\" data-lang=\"pl\" data-count=\"vertical\">Tweet</a>";
					$widget_content .= "<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0];if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=\"//platform.twitter.com/widgets.js\";fjs.parentNode.insertBefore(js,fjs);}}(document,\"script\",\"twitter-wjs\");</script></td>\n";
				}
				$widget_content .= "</tr></table>\n";
			}
		}
		$widget_content .= "</ul>\n";
		echo __($widget_content, 'text_domain');
		$parametry = unserialize(base64_decode($wpdb->get_var("SELECT wartosc FROM $table_name WHERE id=10")));
		if(is_home())
		{
			echo '<a href="'.$parametry['autor'].'" style="float:right;margin-top:10px;margin-bottom:5px"><img src="wp-content/plugins/sbart-stats/sbart-stats.png" alt="'.$parametry['alt'].'"/></a>';
		}
		echo $after_widget;
	}

	public function update($new_instance, $old_instance) 
	{
		$instance = array();
		$instance['title'] = strip_tags($new_instance['title']);
		
		return $instance;
	}


	public function form($instance) 
	{
		if (isset($instance['title'])) 
		{
			$title = $instance['title'];
		}
		else 
		{
			$title = __('Statystyki', 'text_domain');
		}
		?>
		<p>
		<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Tytuł:' ); ?></label> 
		<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
		</p>
		<?php 
	}

}
?>